; Test program for Ion that uses each of the routines in sprite.asm

#ifdef TI83P
#include "ion.inc"
.org    progstart-2
.db     $BB,$6D
#endif

#ifdef TI83
#include "ion.inc"
.org    progstart
#endif

#ifdef TI86
#define equ .equ
#include "ti86.inc"
.org    _asm_exec_ram
#define SPRITE_86
#define bcall(xxxx) call xxxx
#endif

#ifndef TI86
        ret
        jr      nc,start
.db     "Sprite Routine Tester",0
#else
        nop
        jp      start
        .dw     0
        .dw     title
title:
.db     "Sprite Routine Tester",0
#endif

start:
        bcall(_grbufclr)
; Use putAlignedSprite
        ld      a,5
        ld      l,6
        ld      de,sprFace
        call    putAlignedSprite
; Use putMaskedAlignedSprite
        ld      a,3
        ld      l,1
        ld      de,sprCheckered
        call    putAlignedSprite
        ld      a,3
        ld      l,1
        ld      de,sprMaskedFace
        call    putMaskedAlignedSprite
; Use putSprite
        ld      a,53
        ld      l,21
        ld      de,sprCheckered
        call    putSprite
; Use putClippedSprite
        ld      b,-3
        ld      c,59
        ld      hl,sprFace
        call    putClippedSprite
        ld      b,-3
        ld      c,59
        ld      hl,sprCheckered
        call    putClippedSprite
; Use putClippedMaskedSprite
#ifdef TI86
        ld      b,125
        ld      c,-2
#else
        ld      b,93
        ld      c,-2
#endif
        ld      hl,sprMaskedFace
        call    putClippedMaskedSprite
; Copy gbuf to video, wait for a key then quit
        call    ionFastCopy
        bcall(_getkey)
        ret

#ifdef TI86
_grbufclr:
        ld      hl,gbuf
        ld      de,gbuf+1
        ld      bc,1023
        ld      (hl),0
        ldir
        ret

ionFastCopy:
        ld      hl,gbuf
        ld      de,$FC00
        ld      bc,1024
        ldir
        ret
#endif

#define PUT_ALIGNED_SPRITE
#define PUT_MASKED_ALIGNED_SPRITE
#define PUT_SPRITE
#define PUT_CLIPPED_SPRITE
#define PUT_CLIPPED_MASKED_SPRITE
#include "sprite.asm"

sprFace:
.db %00111100
.db %01000010
.db %10100101
.db %10000001
.db %10100101
.db %10011001
.db %01000010
.db %00111100

sprCheckered:
.db %10101010
.db %01010101
.db %10101010
.db %01010101
.db %10101010
.db %01010101
.db %10101010
.db %01010101

sprMaskedFace:
.db %00111100
.db %01000010
.db %10100101
.db %10000001
.db %10100101
.db %10011001
.db %01000010
.db %00111100
.db %00111100
.db %01111110
.db %11111111
.db %11111111
.db %11111111
.db %11111111
.db %01111110
.db %00111100

.end
